



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Android 界面效果45】ViewPager源码分析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Android 界面效果45】ViewPager源码分析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-27 07:58:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>ViewPager概述：</h2>
<p>Layout manager that allows the user to flip left and right through pages of data. You supply an implementation of a PagerAdapter to generate the pages that the view shows. <br />Note this class is currently under early design and development. The API will likely change in later updates of the compatibility library, requiring changes to the source code of apps when they are compiled against the newer version. <br />ViewPager is most often used in conjunction with android.app.Fragment, which is a convenient way to supply and manage the lifecycle of each page. There are standard adapters implemented for using fragments with the ViewPager, which cover the most common use cases. These are android.support.v4.app.FragmentPagerAdapter and android.support.v4.app.FragmentStatePagerAdapter; each of these classes have simple code showing how to build a full user interface with them. <br />Here is a more complicated example of ViewPager, using it in conjuction with android.app.ActionBar tabs. You can find other examples of using ViewPager in the API 4+ Support Demos and API 13+ Support Demos sample code. <br />&nbsp;{@sample development/samples/Support13Demos/src/com/example/android/supportv13/app/ActionBarTabsPager.java complete}</p>
<p>布局管理器允许用户通过左右滑动的方式浏览数据页面。开发者需要提供产生这些页面的数据适配器---实现PagerAdapter。</p>
<p>值得注意的是，ViewPager这个类目前仍在前期设计和开发阶段，它在今后的兼容包中有可能更新，如果ViewPager在编译时与更新版本冲突就需要修改它的源码。</p>
<p>ViewPager通常与Fragment结合使用，这样可以方便有效的管理各个页面的生命周期。为了让Fragment和ViewPager结合使用，已经有了概含最常见的用例的标准适配器：FragmentPagerAdapter和FragmentStatePagerAdapter.这两个类都是PagerAdapter的子类，都有一些简单的代码来展示如何用他们来创建一个完整的用户接口。</p>
<p>ViewPager有一个更复杂的例子，使用它与ActionBar的tab结合使用。可以在v4和v13支持库的示例代码中找到其他和ViewPager有关的例子。（路径为：development/samples/Support13Demos/src/com/example/android/supportv13/app/ActionBarTabsPager.java）</p>
<p>Support13Demos源码下载：<a href="http://download.csdn.net/detail/dongdong230/8440129" rel="external nofollow noreferrer">http://download.csdn.net/detail/dongdong230/8440129</a></p>
<p>Support13Demos源码下载：<a href="http://download.csdn.net/detail/dongdong230/8440129" rel="external nofollow noreferrer">http://download.csdn.net/detail/dongdong230/8440129</a></p>
<h2>ViewPager方法精选：</h2>
<h3>1.Viewpager继承ViewGroup，需重写其抽象方法<em><strong>OnLayout</strong></em>：</h3>
<p>protected void onLayout (boolean changed, int l, int t, int r, int b)</p>
<p>调用场景：在view给其孩子设置尺寸和位置时被调用。子view，包括孩子在内，必须重写onLayout(boolean, int, int, int, int)方法，并且调用各自的layout(int, int, int, int)方法</p>
<p>几个参数的含义：</p>
<table>
<tbody>
<tr>
<th>changed</th>
<td>view有新的尺寸或位置</td>
</tr>
<tr>
<th>l</th>
<td>相对于父view的Left位置</td>
</tr>
<tr>
<th>t</th>
<td>相对于父view的Top位置</td>
</tr>
<tr>
<th>r</th>
<td>相对于父view的Right位置</td>
</tr>
<tr>
<th>b</th>
<td>相对于父view的Bottom位置</td>
</tr>
</tbody>
</table>
<p>这里分别对decor view 和 非decor view进行位置移动，依据是srollx及offset。</p>
<h3>2.ViewPager的内部类：LayoutParams：</h3>
<p>Layout parameters that should be supplied for views added to a ViewPager。</p>
<p>这是为viewpager页面子view准备的布局参数类。</p>
<p>其中的几个重要字段：</p>
<table>
<tbody>
<tr>
<th>isDecor</th>
<td>true:该view是pager自身的而非适配器适配的</td>
</tr>
<tr>
<th>gravity</th>
<td>仅为decor view使用，布局子view的位置，常量值在android.view.Gravity中</td>
</tr>
<tr>
<th>widthFactor</th>
<td>页面宽度的乘数因子？</td>
</tr>
<tr>
<th>needsMeasure</th>
<td>true：该view在正layout时被添加，且在布局这个view前需测量</td>
</tr>
<tr>
<th>position</th>
<td>非decorview的view所适配的位置</td>
</tr>
</tbody>
</table>
<h3>3.ViewPager重要接口OnPageChangeListener：</h3>
<p>三个未实现的方法：onPageScrolled、onPageSelected、onPageScrollStateChanged</p>
<p>最常用接口，无需多说。</p>
<p>另有内部类SimpleOnPageChangeListener：实现了OnPageChangeListener方法，但没有写实现代码，如果不想重写OnPageChangeListener所有方法，使用这个内部类即可。</p>
<h3>4.滑动动画接口：PageTransformer：页面滑动时所展现的动画效果</h3>
<p>transformPage：给指定页面添加滑动动画</p>
<h3>5.其他方法</h3>
<ol><li>addFocusables：当前显示的页面方可获取焦点</li>
<li>addTouchables：当前显示的页面方可获取触摸事件</li>
<li>addView：根据指定布局参数添加子view</li>
<li>arrowScroll：滑动的方向？</li>
<li>beginFakeDrag：开始控制滑动事件，处于fake drag时，viewpager会忽略掉touch事件</li>
<li>canScrollHorizontally：判断view是否可在指定方向（derection）上水平滑动.derection:负数代表向左，正数代表向右</li>
<li>computeScroll：由父类调用，计算其子类所应滑动的距离</li>
<li>dispatchKeyEvent：分发key事件</li>
<li>dispatchPopulateAccessibilityEvent：分发辅助事件给view，然后将其子类的text content添加到这个事件中。</li>
<li>draw：绘制view及其子view到canvas上。</li>
<li>endFakeDrag：结束控制滑动事件</li>
<li>executeKeyEvent：执行key事件</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlo41xq.html">XVI Open Cup named after E&period;V&period; Pankratiev&period; GP of Eurasia</a>
		</li>
						<li><a href="https://www.batexi.com/a/495dp70q.html">CocoaPods安装记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93rwrn9.html">MVC &amp;ndash&semi; 6&period;控制器 Action方法参数与返回值</a>
		</li>
						<li><a href="https://www.batexi.com/a/r931pwz8.html">提示此windows副本不是正版的win7系统7601解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zwdw18.html">单链表List的C实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvdw5oq.html">USACO Section 3&period;1&colon; Stamps</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0olm8.html">jeecms子栏目或者文章页导航父栏目选中解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okwwkl9.html">标签form表单里的属性简单介绍了一下</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0llx9.html">REST client 基于浏览器的测试工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zxgz49.html">关于js中alert弹出窗口换行！</a>
		</li>
						<li><a href="https://www.batexi.com/a/90volm38.html">git创建与合并分支</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzz32l8.html">ASP&period;NET MVC 3&colon; Razor中的&commat;&colon;和语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5rze8.html">Vnix项目正式启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zo2pj9.html">win10彻底禁用自动更新，win10怎样彻底关闭自动更新，永久关闭win10自动更新，win10更新助手</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyo47x9.html">xmlns 啥意思</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjj1779.html">mysql几种中间件对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r503kmq.html">hdfs数据到hive中，以及hdfs数据隐身理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r412j9.html">Spring Cloud 请求重试机制核心代码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25e163q.html">玩魔兽争霸无故退出 提示框显示&amp;quot&semi;0x21101663&amp;quot&semi;指令引用的&amp;quot&semi;0x02704acc&amp;quot&semi;内存该存不能为&amp;quot&semi;read&amp;quot&semi; 确定就会终止程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r7yd48.html">Javascript 第五章总结：A trip to Objectville</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95xmlx08.html">oracle学习 三（持续更新中）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zpo549.html">&lbrack;置顶&rsqb; 如何在浏览器中打开PDF文件并实现预览的思路与代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd5yel8.html">JSP文件下载时文件名在ie和firefox下面文件名不一致极其超链接中文乱码的问题的改进</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xd2yz9.html">input value的值不可改变</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmn3109.html">C语言的struct&sol;union字节对齐</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xd2j09.html">maven profile动态选择配置文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdedy709.html">Oracle复制表结构和表数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvzx1jq.html">基于jQuery 常用WEB控件收集</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zpe449.html">BZOJ 2038 &lbrack;2009国家集训队&rsqb;小Z的袜子 莫队</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ymxoeq.html">Codeforces Round &num;308 &lpar;Div&period; 2&rpar; D&period; Vanya and Triangles 水题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
